--[[	ChatLinkIcons Core
	by SDPhantom
	http://www.phantomweb.org	]]
------------------------------------------

----------------------------------
--[[	Options Variable	]]
----------------------------------
local Name,AddOn=...;
local Options=AddOn.Options;
local MsgTag=("|TInterface\\AddOns\\%s\\Blank:1|t"):format(Name);

--------------------------
--[[	Other Locals	]]
--------------------------
local TypeConv={
	enchant="spell";
	trade="spell";
	BNplayer="player";
	unit="player";
};
--local PresenceIDConv={};

--------------------------
--[[	Texture Tables	]]
--------------------------
--	|Tpath:size1:size2:xoffset:yoffset:dimx:dimy:coordx1:coordx2:coordy1:coordy2|t
local Races={--		Races/Genders
	Human2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:0:64:0:64|t";
	Human3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:0:64:128:192|t";
	Tauren2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:0:64:64:128|t";
	Tauren3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:0:64:192:256|t";
	Dwarf2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:64:128:0:64|t";
	Dwarf3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:64:128:128:192|t";
	Scourge2	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:64:128:64:128|t";
	Scourge3	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:64:128:192:256|t";
	Gnome2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:128:192:0:64|t";
	Gnome3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:128:192:128:192|t";
	Troll2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:128:192:64:128|t";
	Troll3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:128:192:192:256|t";
	NightElf2	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:192:256:0:64|t";
	NightElf3	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:192:256:128:192|t";
	Orc2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:192:256:64:128|t";
	Orc3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:192:256:192:256|t";
	Draenei2	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:256:320:0:64|t";
	Draenei3	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:256:320:128:192|t";
	BloodElf2	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:256:320:64:128|t";
	BloodElf3	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:256:320:192:256|t";
	Worgen2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:320:384:0:64|t";
	Worgen3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:320:384:128:192|t";
	Goblin2		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:320:384:64:128|t";
	Goblin3		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:320:384:192:256|t";
	Pandaren2	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:0:64|t";
	Pandaren3	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:128:192|t";

--[[	Future entries for Alliance/Horde differentiation if we ever get the ability
	Pandaren2Alliance	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:0:64|t";
	Pandaren3Alliance	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:128:192|t";
	Pandaren2Horde		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:64:128|t";
	Pandaren3Horde		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races:0:0:0:0:512:256:384:448:192:256|t";
--]]
};
local Classes={--		Classes
	WARRIOR		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:0:64:0:64|t";
	MAGE		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:64:128:0:64|t";
	ROGUE		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:128:192:0:64|t";
	DRUID		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:192:256:0:64|t";
	HUNTER		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:0:64:64:128|t";
	SHAMAN		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:64:128:64:128|t";
	PRIEST		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:128:192:64:128|t";
	WARLOCK		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:192:256:64:128|t";
	PALADIN		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:0:64:128:192|t";
	DEATHKNIGHT	="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:64:128:128:192|t";
	MONK		="|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:256:256:128:192:128:192|t";
};

--------------------------
--[[	Link Transform	]]
--------------------------
local PlayerCache={};
local LinkCache={};

local function ConvertLink(link,...)--			Conversion Function
	local tex,type,id,text="",...;
	if select("#",...)<3 then type,id,text=link:match("|H([^:]+):(.-)|h(.-)|h"); end
	local convtype=TypeConv[type] or type;

	if type=="achievement" then
		tex=("|T%s:0|t"):format(select(10,GetAchievementInfo(tonumber(id:match("%d+")))));
--[[	elseif type=="BNplayer" then
--		Called by BNet_GetPresenceID() as an alias
--		Gets the PresenceID out of a RealID name link
		local presid=GetAutoCompletePresenceID(id:match("|K[gsf]%d+|k0+|k"));
		local _,name,client,realm,faction,race,class,guild,zone,level,gametext=nil;--Dump(BNGetToonInfo(presid));

--		There's no way to get character gender from BNPlayer
--		Maybe default to one later?
--]]
	elseif type=="item" then
		tex=("|T%s:0|t"):format(GetItemIcon(tonumber(id:match("%d+"))));
	elseif type=="player" then
		local guid=PlayerCache[id:match("[^:]+")];
		if guid then
			local _,class,_,race,gender=GetPlayerInfoByGUID(guid);
			if class then
				tex=("%s%s"):format(
					Options.Icons.Race and Races[race..gender] or ""
					,Options.Icons.Class and Classes[class] or ""
				);
			end
		end
	elseif convtype=="spell" then
		tex=("|T%s:0|t"):format(select(3,GetSpellInfo(tonumber(id:match("%d+")))));
--	elseif type=="talent" then
--		There is no API to support talents directly without building a database
	elseif type=="unit" then
		local guid,name=id:match("(.+):(.+)");
		local _,class,_,race,gender=GetPlayerInfoByGUID(guid);
		if class then
			tex=("%s%s"):format(
				Options.Icons.Race and Races[race..gender] or ""
				,Options.Icons.Class and Classes[class] or ""
			);
		end
	end
	return tex..link;
end

local function ConvertLinkHelper(pre,link,...)--	Caching PCall/GSub Helper Function
--	Need to let the code run even if saved options doesn't have a record for the link  (for future versions without needing a config wipe)
	local type=(...) or link:match("|H([^:]+).-|h");
	if Options.Links[TypeConv[type] or type]==false then return pre..link; end

	if #pre%2>0 then return pre..link; end--			Don't fall for a fake link if the pipe char starting the link is escaped
	if LinkCache[link] then return pre..LinkCache[link]; end--	If we have a cached link, use it

--	Rarely the game doesn't give us the icons we need in the time we need them
--	Leting any error halt conversion and return the unchanged link
	local status,newlink=pcall(ConvertLink,link,...);
	if status then
--		If we didn't change anything, don't cache it
		if newlink~=link then LinkCache[link]=newlink; end
		return pre..newlink;
	else
		return pre..link;
	end
end

function AddOn.RecompileLinks(type)--			Recompilation Function
	for i,j in pairs(LinkCache) do
		if type==nil or i:match("|H([^:]+):.-|h.-|h")==type then
--			Need to invalidate the entry so ConvertChatLinkHelper() doesn't return our old link
--			Setting to false will fool the check and still keep the entry in the table
			LinkCache[i]=false;
			ConvertChatLinkHelper("",i:match("(|H([^:]+):(.-)|h(.-)|h)"));
		end
	end
end

--------------------------
--[[	Message Hook	]]
--------------------------
local ChatFrames={};
local ChatMeta=getmetatable(ChatFrame1).__index;
local AddMessage=ChatMeta.AddMessage;
function ChatMeta.AddMessage(self,msg,...)
	local name=self:GetName();
	if ChatFrames[self] or (name and name:find("^ChatFrame%d+$")) then
		ChatFrames[self]=true;

--		local msg=tostring(msg);--	Force message to string
		if type(msg)=="string" and not msg:find(("%s$"):format(MsgTag:gsub("[%$%%%(%)%*%+%-%.%?%[%]%^]","%%%0"))) then
			local fix;msg,fix=msg:gsub("(|*)(|H([^:]+):(.-)|h(.-)|h)",ConvertLinkHelper);
			if fix>0 then msg=("%s%s"):format(msg,MsgTag); end--					Append our tag to track if this message was handled before
			while fix>0 do msg,fix=msg:gsub("(|c%x%x%x%x%x%x%x%x)(%s*|T.-|t%s*)","%2%1"); end--	Fix some links relinking with textures and blocking the ability to send them
		end
	end
	return AddMessage(self,msg,...);
end;

--------------------------
--[[	Event Hooks	]]
--------------------------
--	The following code pre-hooks all chat frames to gather needed player info before each frame displays it

local function EventHandler(self,event,...)
	if event:find("^CHAT_MSG_") then
		if ChatTypeInfo[event:sub(10):gsub("^WHISPER.*","WHISPER"):gsub("^CHANNEL.*","CHANNEL"..(select(8,...) or ""))] then
--			WoW has been known to drop server names from the sender shortly after loading an area
--			This updates the stored GUID anyway in case this causes corruption in the cache
			local _,name,_,_,_,_,_,_,_,_,_,guid=...;
			if (guid or "")~="" then PlayerCache[name]=guid; end
		end

--[[		No BNPlayer support yet
		if ctype=="BN_INLINE_TOAST_ALERT" and (...)=="FRIEND_ONLINE" then
--			We need to recomplile BNPlayer links in case they log in on a new char
			AddOn.RecompileLinks("BNplayer");
		end
--]]
	end
end

local HookedFrames={};
local function HookChatFrameEvents(frame)
	if frame and not HookedFrames[frame] then
		local func=frame:GetScript("OnEvent");
		frame:SetScript("OnEvent",func and function(...) EventHandler(...); func(...); end or EventHandler);
		HookedFrames[frame]=true;
	end
	return frame;--	Enables passthrough calling
end

for i=1,NUM_CHAT_WINDOWS do HookChatFrameEvents(_G["ChatFrame"..i]); end
local FCF_OpenTemporaryWindow=FCF_OpenTemporaryWindow;
function _G.FCF_OpenTemporaryWindow(...) return HookChatFrameEvents(FCF_OpenTemporaryWindow(...)); end;
